// ===----------------------------------------------------------------------===//
// Copyright © 2024 Apple Inc. and the Pkl project authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//	https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ===----------------------------------------------------------------------===//
@Unlisted
abstract module temp.pkl.swift.internal.Gen

import "SwiftMapping.pkl"

/// The generated contents for this particular mapping.
mapping: SwiftMapping

/// All mappings
mappings: List<SwiftMapping>

/// The Swift source code
contents: String

/// Swift source code to be put outside the extension, at the top level
topLevelContents: String?

/// The name of the namespace
namespaceName: String

/// The indentation applied to generated Swift code.
indent: String