// ===----------------------------------------------------------------------===//
// Copyright © 2024 Apple Inc. and the Pkl project authors. All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//	https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
// ===----------------------------------------------------------------------===//
amends "pkl:test"

import "../internal/utils.pkl"

facts {
  ["normalizeName"] {
    utils.normalizeName("foo") == "foo"
    utils.normalizeName("foo foo") == "fooFoo"
    utils.normalizeName("1 foo") == "1Foo"
    utils.normalizeName("bar ` $$ 你好 baz") == "bar你好Baz"
    utils.normalizeName("Swift111") == "Swift111"
    utils.normalizeName("snake_case") == "snake_case"
  }
  ["toSwiftString"] {
    utils.toSwiftString("foo") == #""foo""#
    utils.toSwiftString("你好") == #""你好""#
    utils.toSwiftString(#"pkl:"name""#) == ##"#"pkl:"name""#"##
    utils.toSwiftString("""
      my multiline

      string
      """) == #"""
        """
          my multiline
          
          string
          """
        """#
    utils.toSwiftString("""
      multiline string

      with `backticks`
      """) == #"""
        """
          multiline string
          
          with `backticks`
          """
        """#
  }
}
